require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_GRID_LIST 			= '/api/rtnmng/inoutmng/spply-pick-grid-list';	// 목록
const API_POP_SEARCH_LIST			= '/api/whs/mng/pop-whs-search';
const API_POP_INFO_PICK 			= '/api/rtnmng/inoutmng/info-pick';

const PAGE_MODE_LIST				= "LIST";
const PAGE_MODE_VIEW				= "VIEW";

let mobPageObj = {
	viewMode: PAGE_MODE_LIST,
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.view();
			this.info();
		},
		view: function() {
			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});

			// 조회일자 지정
			$('#ITP_MOBILE_MCOLLMNG03010 .itp_input.date').datepicker(ITP_DATE_LANGUAGE);
			$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH_FROM_DT').datepicker('setDate', itp_fn_date_add('D', -7));
			$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH_TO_DT').datepicker('setDate', itp_fn_date_add('M', 0));
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
			$('input:hidden[id$="_SPPLY_ID"]').val(fn_make_user_info.get('userId'));
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MCOLLMNG03010_LIST"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MCOLLMNG03010_LIST_SEARCH_WHS_NM'	: mobPopObj.popWhsNm.init(); 	break;
					case 'ITP_BTN_MCOLLMNG03010_LIST_DELETE_WHS_NM'	: mobPopObj.popWhsNm.delete(); 	break;
					case 'ITP_BTN_MCOLLMNG03010_LIST_SEARCH'		: mobContObj.list.search();		break;
					case 'ITP_BTN_MCOLLMNG03010_LIST_COL_VIEW'		: mobContObj.list.colPrint();	break;
				}
				return false;
			});

			$('button[id^="ITP_BTN_MCOLLMNG03010_VIEW"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MCOLLMNG03010_VIEW_ADD'			: mobContObj.view.add();	break;
					case 'ITP_BTN_MCOLLMNG03010_VIEW_CONFIRM'		: mobContObj.view.cancel();	break;
				}
				return false;
			});

			// $(document).on('click', '#ITP_LIST_MCOLLMNG03010_LIST_ITEM_ROWS li', function() {
			// 	mobContObj.list.iChoice = $(this).index();
			// });
			$(document).on('click', 'input[type="checkbox"][id="ITP_LIST_MCOLLMNG03010_LIST_ITEM_CHECKBOX"]', function() {
				if($(this).prop('checked')) {
					$('input[type="checkbox"][id="ITP_LIST_MCOLLMNG03010_LIST_ITEM_CHECKBOX"]').prop('checked', false);
					$(this).prop('checked', true);
				}
			});

			$(document).on('click', '#ITP_LIST_MCOLLMNG03010_POP_WHS_ROWS li button', function() {
				mobPopObj.popWhsNm.choice($(this));
			});
		}
	},
	switchScreen: function(mode) {
		$('#ITP_MOBILE_MCOLLMNG03010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode === PAGE_MODE_LIST) {
			$('#ITP_AJAX_MCOLLMNG03010_LIST_CONTAINER').show();
		} else if(mode === PAGE_MODE_VIEW) {
			$('#ITP_AJAX_MCOLLMNG03010_VIEW_CONTAINER').show();
			CommonObj.moreView('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_AREA', false);
		}
		this.viewMode = mode;
	},
	ready: function() {
		mobContObj.list.init();
	}
};

let mobContObj = {
	list: {
		listPage: 1,
		rows: [],
		init: function() {
			mobPageObj.switchScreen(PAGE_MODE_LIST);
			this.search();
		},
		search: function() {
			this.listPage = 1;
			this.rows.length = 0;
			$('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_ROWS').empty();
			this.load();
		},
		pager: function(totPage) {
			(this.listPage < totPage) ?
				CommonObj.moreView('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_AREA', true, mobContObj.list.load) :
				CommonObj.moreView('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_AREA', false);
			this.listPage += 1;
		},
		load: function() {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				mobContObj.list.pager(result.gridTotal);
				$.each(result.gridRows, function (i, item) {
					$('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_AREA .panel-group').append($('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_ROWCOPY').html());
					var $li = $('#ITP_LIST_MCOLLMNG03010_LIST_ITEM_AREA .panel-group > .item-row:last');
					$li.find('.fnBrandNm').text(item.brandNm);
					$li.find('.fnItemNm').text(item.itemNm);
					$li.find('.fnColPickUnqNo').text(item.colPickUnqNo);
					$li.find('.fnPickStNm').text(item.pickStNm);
					$li.find('.fnColRegDt').text(item.colRegDt);
					$li.find('.fnColReqDt').text(item.colReqDt);
					$li.find('.fnColSchDt').text(item.colSchDt);
					$li.find('.fnColReqQty').text(CommonObj.currency.add(item.colReqQty, '개'));
					$li.find('.fnColReqAmt').text(CommonObj.currency.add(item.colReqAmt));
					$li.find('.fnWhsNm').text(item.whsNm);
					$li.find('.fnPickMgrNm').text(item.pickMgrNm);
					mobContObj.list.rows.push(item);
				});
			};
			var errFn = function() { _this.isSearch = false;};
			const param = $('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH').serializeObject();
			param.gridPage = mobContObj.list.listPage;
			param.gridSize = mobile_list_size;
			fn_ajax_call(API_MOBILE_GRID_LIST, JSON.stringify(param), callbackFn, 'POST', errFn);
		},
		colPrint: function() {
			var iChoice = -1;
			$('input[type="checkbox"][id="ITP_LIST_MCOLLMNG03010_LIST_ITEM_CHECKBOX"]').each(function(index) {
				if($(this).is(":checked")) {
					iChoice = index;
					return false;
				}
			});
			if(iChoice === -1) {
				alert("수거서를 선택해주세요 (대표 수거서번호)");
				return;
			}
			mobContObj.view.init(this.rows[iChoice]);
		}
	},
	view: {
		rows: [],
		init: function(item) {
			mobPageObj.switchScreen(PAGE_MODE_VIEW);
			this.reset();
			this.search(item);
		},
		search: function(item) {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result);
			};
			const param = {
				'brandId': fn_make_user_info.get('brandId'),
				'colPickUnqNo': item.colPickUnqNo
			};
			fn_ajax_call(API_POP_INFO_PICK, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(result) {
			var _this = this;
			var id = '#ITP_AJAX_MCOLLMNG03010_VIEW_CONTAINER';
			$(id).find('.fnColRegDt').text(result.colRegDt);
			$(id).find('.fnColPickUnqNo').text(result.colPickUnqNo);
			$(id).find('.fnColSchDt').text(result.colSchDt);
			$(id).find('.fnPickMgrNm').text(result.pickMgrNm);
			$(id).find('.fnWhsAddr').text(result.whsAddr);
			$(id).find('.fnPndrTelNo').text(result.pndrTelNo);

			$(id).find('.fnRtnBsnsRegno').text(result.rtnBsnsRegno);
			$(id).find('.fnRtnNm').text(result.rtnNm);
			$(id).find('.fnRtnOwnerNm').text(result.rtnOwnerNm);
			$(id).find('.fnRtnAddr').text(result.rtnAddr);

			$(id).find('.fnColBsnsRegNo').text(result.colBsnsRegno);
			$(id).find('.fnColNm').text(result.colNm);
			$(id).find('.fnColOwnerNm').text(result.colOwnerNm);
			$(id).find('.fnColAddr').text(result.colAddr);
			$.each(result.pickDtlInfoList, function (i, item) {
				$('#ITP_LIST_MCOLLMNG03010_VIEW_ITEM_AREA .panel-group').append($('#ITP_LIST_MCOLLMNG03010_VIEW_ITEM_ROWCOPY').html());
				var $li = $('#ITP_LIST_MCOLLMNG03010_VIEW_ITEM_AREA .panel-group > .item-row:last');
				$li.find('.fnRtnPodrUnqNo').text(item.rtnPodrUnqNo);
				$li.find('.fnItemId').text(item.itemId);
				$li.find('.fnItemNm').text(item.itemNm);
				$li.find('.fnRodrQty').text(CommonObj.comma.set(item.rodrQty));
				$li.find('.fnColReqQty').text(CommonObj.comma.set(item.colReqQty));
				$li.find('.fnRtnRsnDvsnNm').text(item.rtnRsnDvsnNm);
				_this.rows.push(item);
			});
		},
		reset: function() {
			var id = '#ITP_AJAX_MCOLLMNG03010_VIEW_CONTAINER';
			$(id).find('.fnColRegDt').text('');
			$(id).find('.fnColPickUnqNo').text('');
			$(id).find('.fnColSchDt').text('');
			$(id).find('.fnColMgrNm').text('');
			$(id).find('.fnWhsAddr').text('');
			$(id).find('.fnPndrTelNo').text('');

			$(id).find('.fnRtnBsnsRegno').text('');
			$(id).find('.fnRtnNm').text('');
			$(id).find('.fnRtnOwnerNm').text('');
			$(id).find('.fnRtnAddr').text('');

			$(id).find('.fnColBsnsRegNo').text('');
			$(id).find('.fnColNm').text('');
			$(id).find('.fnColOwnerNm').text('');
			$(id).find('.fnColAddr').text('');
			$('#ITP_LIST_MCOLLMNG03010_VIEW_ITEM_AREA .panel-group').empty();
		},
		cancel: function () {
			this.reset();
			mobPageObj.switchScreen(PAGE_MODE_LIST);
		}
	}
};

let mobPopObj = {
	popWhsNm: {
		popId: 'ITP_POP_MCOLLMNG03010_WHS_AREA',
		rows: [],
		init: function () {
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function () {
			var _this = this;
			$('#ITP_LIST_MCOLLMNG03010_POP_WHS_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			const param = $('#ITP_FORM_MCOLLMNG03010_POP_WHS').serializeObject();
			param.swhsDvsn = 'W01';
			fn_ajax_call(API_POP_SEARCH_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_LIST_MCOLLMNG03010_POP_WHS_AREA .panel-group').append($('#ITP_LIST_MCOLLMNG03010_POP_WHS_ROWCOPY').html());
				var $li = $('#ITP_LIST_MCOLLMNG03010_POP_WHS_AREA .panel-group > .item-row:last');
				$li.find('.fnWhsNm').text(item.whsNm);
				$li.find('.fnLocationNm').text(item.locationNm);
				$li.find('.fnWhsId').data('whs-id', item.whsId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var whsId = $(elem).data('whs-id');
			$.each(this.rows, function (i, item) {
				if(whsId === item.whsId) {
					$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH #ITP_FORM_MCOLLMNG03010_LIST_SEARCH_WHS_ID').val(item.whsId);
					$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH #ITP_FORM_MCOLLMNG03010_LIST_SEARCH_WHS_NM').val(item.whsNm);
					_this.close();
					return false;
				}
			});
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MCOLLMNG03010_POP_WHS"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MCOLLMNG03010_POP_WHS_SEARCH'	: _this.search();			break;
					case 'ITP_BTN_MCOLLMNG03010_POP_WHS_CHOICE'	: _this.choice($(this)); 	break;
					case 'ITP_BTN_MCOLLMNG03010_POP_WHS_CLOSE'	: _this.close(); 			break;
				}
				return false;
			});
		},
		delete: function() {
			$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH #ITP_FORM_MCOLLMNG03010_LIST_SEARCH_WHS_ID').val('');
			$('#ITP_FORM_MCOLLMNG03010_LIST_SEARCH #ITP_FORM_MCOLLMNG03010_LIST_SEARCH_WHS_NM').val('');
		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MCOLLMNG03010_LIST_WHS_AREA .panel-group').empty();
			$('#ITP_FORM_MCOLLMNG03010_POP_WHS #ITP_FORM_MCOLLMNG03010_POP_WHS_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	show: function(popId) {
		$('button[id$="_CLOSE"]').off('click').on('click', function() {
			console.log($(this).attr('id'));
			if($(this).hasClass('btn-pop-close')) {
				mobPopObj.hide(popId);
			}
		});
		$('#' + popId).show();
	},
	hide: function(popId) {
		$('#' + popId).closest('.mobile-pop-close').hide();
	}
};
